!Copyright (c) 2016 Mikhail Kruglyakov 
!This file is part of GIEM2G.
!
!GIEM2G is free software: you can redistribute it and/or modify
!it under the terms of the GNU General Public License as published by
!the Free Software Foundation, either version 2 of the License.
!
!GIEM2G is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with GIEM2G.  If not, see <http://www.gnu.org/licenses/>.
!
!
!

MODULE MPI_SAVELOAD_MODULE
    USE CONST_MODULE
    USE DATA_TYPES_MODULE
#ifndef LEGACY_MPI
    USE MPI
#endif
    USE PGIEM2G_LOGGER_MODULE
    USE TIMER_MODULE
    USE FSON
    USE FSON_VALUE_M, ONLY: FSON_VALUE_COUNT, FSON_VALUE_GET
    USE POLYNOMIAL_UTILITIES_MODULE
    USE LOCAL_OUTPUT_MODULE
    IMPLICIT NONE
#ifdef LEGACY_MPI
	INCLUDE 'mpif.h'
#endif

    PRIVATE 
    INTEGER,  PARAMETER::MPI_CTL_KIND=KIND(MPI_COMM_WORLD)
    INTEGER,  PARAMETER::DEFAULT_UNIT=79

    PUBLIC :: LoadBackground, LoadAnomalyShape, LoadSourceDomain
    PUBLIC :: LOAD_SCALAR_CONDUCTIVITY
    PUBLIC :: LOAD_FREQUENCIES_FROM_LIST, LOAD_FREQUENCIES_FROM_SOURCES
    PUBLIC :: LOAD_SOURCE, LOAD_RECIEVERS
    PUBLIC :: GET_FREQ_BY_INDEX, GET_RECV_LAT_BOUNDARIES
    PUBLIC :: LoadFGMRES_Ctl,LOAD_SOLVER_CTL
    PUBLIC :: SaveOutputOneFile_SingleType, SaveOutputOneFile
    PUBLIC :: LOAD_POLYNOMIAL_DATA, LOAD_DOMAIN_SHAPE, LoadStations
    PUBLIC :: LoadIESolutionOneFileBinary, SaveIESolutionOneFileBinary
    PUBLIC :: PRINT_TENSOR_COMPONENT
CONTAINS


    SUBROUTINE LoadBackground(bkg, comm, input_data)
        TYPE(BKG_DATA_TYPE),INTENT(INOUT)::bkg
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        TYPE(FSON_VALUE), POINTER :: check_item
        INTEGER(MPI_CTL_KIND)::me,IERROR
        INTEGER::N,I
        REAL(DOUBLEPARM),ALLOCATABLE::tmp(:)
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Background.Conductivity", tmp)
            N=SIZE(tmp);
            bkg%Nl=N
            ALLOCATE (bkg%sigma(N), bkg%thick(1:N-1), bkg%depth(1:N-1),bkg%csigma(0:N))
            bkg%sigma=tmp
            DEALLOCATE(tmp)
            IF (N>1) THEN
                CALL FSON_GET(input_data, "Background.Thickness", tmp)
                bkg%thick=ROUND10(tmp)
                DEALLOCATE(tmp)
            ENDIF
        ENDIF
        CALL MPI_BCAST(N,1,MPI_INTEGER, 0, comm, IERROR)
        IF (me/=0) THEN 
            bkg%Nl=N
            ALLOCATE (bkg%sigma(N), bkg%thick(1:N-1), bkg%depth(1:N-1),bkg%csigma(0:N))
        ENDIF
        ALLOCATE (bkg%k(0:N),bkg%k2(0:N))
        CALL MPI_BCAST(bkg%sigma,N,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        IF (N>1) THEN
            CALL MPI_BCAST(bkg%thick,N-1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
            bkg%depth(1)=bkg%thick(1)
            DO I=2,N-1
                bkg%depth(I)=bkg%depth(I-1)+bkg%thick(I)
            END DO
        ENDIF
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Background.Upper halfspace", check_item)
            IF (ASSOCIATED(check_item)) THEN
                CALL FSON_GET(check_item, "", bkg%sigma_space)
            ELSE
                bkg%sigma_space=DEFAULT_SPACE_CONDUCTIVITY
            ENDIF
        ENDIF

        CALL MPI_BCAST(bkg%sigma_space, 1, MPI_DOUBLE_PRECISION, 0, comm, IERROR)
    ENDSUBROUTINE

    SUBROUTINE LoadAnomalyShape(anomaly,bkg,comm,input_data)
        TYPE (ANOMALY_TYPE),INTENT(INOUT)::anomaly
        TYPE (BKG_DATA_TYPE),TARGET,INTENT(IN)::bkg
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        CALL LOAD_DOMAIN_SHAPE(anomaly, "Anomaly", comm, input_data)
        CALL SET_BKG_LAYERS(bkg, anomaly)
    ENDSUBROUTINE

    SUBROUTINE LoadSourceDomain(anomaly,  comm, input_data, src_type)
        TYPE (ANOMALY_TYPE),INTENT(INOUT)::anomaly
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        INTEGER, INTENT(OUT) :: src_type
        src_type=1
        CALL LOAD_DOMAIN_SHAPE(anomaly, "Source Domain", comm, input_data, src_type)
    ENDSUBROUTINE

    SUBROUTINE LOAD_DOMAIN_SHAPE(domain, d_name, comm, input_data, src_type)
        TYPE (ANOMALY_TYPE),INTENT(INOUT)::domain
        CHARACTER(len=*), INTENT(IN) :: d_name
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        INTEGER, INTENT(OUT), OPTIONAL :: src_type
        INTEGER(MPI_CTL_KIND)::IERROR,me
        INTEGER::Nx,Ny,Nz,lb(1)
        REAL(DOUBLEPARM)::dx,dy
        REAL(DOUBLEPARM),ALLOCATABLE::zb(:)
        TYPE(FSON_VALUE), POINTER :: domain_data, check
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, d_name, domain_data)
             

            CALL FSON_GET(domain_data, "Nx", Nx)
            CALL FSON_GET(domain_data, "Ny", Ny)
            CALL FSON_GET(domain_data, "Nz", Nz)
            CALL FSON_GET(domain_data, "dx", dx)
            CALL FSON_GET(domain_data, "dy", dy)
            IF (PRESENT(src_type)) THEN
                CALL FSON_GET(domain_data, "Type", check)
                IF (ASSOCIATED(check)) THEN
                    CALL FSON_GET(check, "", src_type)
                ELSE
                    src_type=1
                ENDIF 
            ENDIF
        ENDIF
        CALL MPI_BCAST(Nx,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(Ny,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(Nz,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(dx,1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        CALL MPI_BCAST(dy,1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        IF (PRESENT(src_type)) THEN
            CALL MPI_BCAST(src_type,1,MPI_INTEGER, 0, comm, IERROR)
        ENDIF
        domain%Nx=Nx
        domain%Ny=Ny
        domain%Nz=Nz
        domain%dx=dx
        domain%dy=dy
        IF (ALLOCATED(domain%z)) DEALLOCATE(domain%z)
        IF (ALLOCATED(domain%Lnumber)) DEALLOCATE(domain%Lnumber)
        IF (ALLOCATED(domain%dz)) DEALLOCATE(domain%dz)
        ALLOCATE(domain%z(0:Nz),domain%Lnumber(0:Nz),domain%dz(Nz))
        IF (me==0) THEN
            CALL FSON_GET(domain_data, "zborders", zb)
            lb=LBOUND(zb)
            domain%z=ROUND10(zb(lb(1):lb(1)+Nz))
            DEALLOCATE(zb)
        ENDIF
        CALL MPI_BCAST(domain%z,Nz+1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        domain%dz=domain%z(1:Nz)-domain%z(0:Nz-1)
    ENDSUBROUTINE


    SUBROUTINE LoadAnomalyShapeBlock(anomaly,bkg,comm,input_data)
        TYPE (ANOMALY_TYPE),INTENT(INOUT)::anomaly
        TYPE (BKG_DATA_TYPE),TARGET,INTENT(IN)::bkg
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        INTEGER(MPI_CTL_KIND)::IERROR,me
        INTEGER::Nx,Ny,Nz,lb(1),I
        REAL(DOUBLEPARM)::dx,dy,dz
        REAL(DOUBLEPARM),ALLOCATABLE::zb(:)
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Anomaly.Nx", Nx)
            CALL FSON_GET(input_data, "Anomaly.Ny", Ny)
            CALL FSON_GET(input_data, "Anomaly.Nz", Nz)
            CALL FSON_GET(input_data, "Anomaly.dx", dx)
            CALL FSON_GET(input_data, "Anomaly.dy", dy)
        ENDIF
        CALL MPI_BCAST(Nx,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(Ny,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(Nz,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(dx,1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        CALL MPI_BCAST(dy,1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        anomaly%Nx=Nx
        anomaly%Ny=Ny
        anomaly%Nz=Nz
        anomaly%dx=dx
        anomaly%dy=dy
        !anomaly%z=>NULL()
        !anomaly%Lnumber=>NULL()
        IF (ALLOCATED(anomaly%z)) DEALLOCATE(anomaly%z)
        IF (ALLOCATED(anomaly%Lnumber)) DEALLOCATE(anomaly%Lnumber)
        IF (ALLOCATED(anomaly%dz)) DEALLOCATE(anomaly%dz)
        ALLOCATE(anomaly%z(0:Nz),anomaly%Lnumber(0:Nz),anomaly%dz(Nz))
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Anomaly.zborders", zb)
            lb=LBOUND(zb)
            dz=(zb(lb(1)+1)-zb(lb(1)))/Nz
            anomaly%z(0)=zb(lb(1))
            DO I=1,Nz
                anomaly%z(I)=anomaly%z(I-1)+dz
            ENDDO
            DEALLOCATE(zb)
        ENDIF
        CALL MPI_BCAST(anomaly%z,Nz+1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        anomaly%Lnumber(1:Nz)=GetLayer((anomaly%z(0:Nz-1)+anomaly%z(1:Nz))/2d0,bkg)
        anomaly%Lnumber(0)=GetLayer(anomaly%z(0)*(1d0-1d-7),bkg)
        anomaly%dz=anomaly%z(1:Nz)-anomaly%z(0:Nz-1)

        IF (me==0) THEN
            IF  (GetLayer(anomaly%z(0)*(1d0-1d-7),bkg)/=GetLayer(anomaly%z(0)*(1d0+1d-7),bkg)) THEN
                CALL Logger('z(0) is on layers border, is not it?')
            ENDIF
        ENDIF
    ENDSUBROUTINE

    SUBROUTINE LOAD_SCALAR_CONDUCTIVITY(siga,comm,input_data)
        REAL(REALPARM),POINTER,INTENT(IN)::siga(:,:,:)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        CHARACTER(len=4096)::anomaly_sig
        REAL(REALPARM),ALLOCATABLE::siga1(:,:,:)
        INTEGER(MPI_CTL_KIND)::IERROR,me,csize
        INTEGER::Nc, I
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        REAL(DOUBLEPARM)::time1,time2
        INTEGER::fd=DEFAULT_UNIT
        INTEGER::Nx,Ny_loc,Nz        
        CHARACTER(len=:), ALLOCATABLE :: str
        time1=GetTime()
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        Nz=SIZE(siga,1)
        Nx=SIZE(siga,2)
        Ny_loc=SIZE(siga,3)
        Nc=Nx*Nz*Ny_loc
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Anomaly.Conductivity", str)
            anomaly_sig=str
            CALL LOGGER('Loading sigma from '//anomaly_sig)
            OPEN(UNIT=fd,file=anomaly_sig)
            ALLOCATE(siga1(Nz,Nx,Ny_loc))
            READ(fd,*) siga
            DO I=1,csize-1
                READ(fd,*) siga1
                CALL MPI_SEND(siga1, Nc, MPI_DOUBLE_PRECISION, I, I, comm, IERROR)
            ENDDO
            CLOSE(fd)
        ELSE
            CALL MPI_RECV(siga, Nc, MPI_DOUBLE_PRECISION,0, me,  comm,REC_STATUS, IERROR)
        ENDIF
        CALL MPI_BARRIER(comm,IERROR)
        time2=GetTime()
        IF (me==0) THEN
            DEALLOCATE(siga1)
            CALL PRINT_CALC_TIME('Conductivity is  loaded in' ,time2-time1)
        ENDIF
    ENDSUBROUTINE
    SUBROUTINE LoadAnomalySigma(anomaly,comm,input_data)
        TYPE (ANOMALY_TYPE),INTENT(INOUT)::anomaly
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        CHARACTER(len=4096)::anomaly_sig
        REAL(REALPARM),ALLOCATABLE::siga1(:,:,:)
        INTEGER(MPI_CTL_KIND)::IERROR,me,csize
        INTEGER::Nc,io,I
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        REAL(8)::time1,time2
        CHARACTER(len=:), ALLOCATABLE :: str
        INTEGER::fd=DEFAULT_UNIT    
        time1=MPI_WTIME()
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        Nc=anomaly%Nx*anomaly%Nz*anomaly%Ny_loc
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Anomaly.Conductivity", str)
            anomaly_sig=str
            CALL LOGGER('Loading sigma from '//anomaly_sig)
            OPEN(UNIT=fd,file=anomaly_sig)
            ALLOCATE(siga1(anomaly%Nz,anomaly%Nx,anomaly%Ny_loc))
            READ(fd,*) anomaly%siga
            DO I=1,csize-1
                READ(fd,*) siga1
                CALL MPI_SEND(siga1, Nc, MPI_DOUBLE_PRECISION, I, I, comm, IERROR)
            ENDDO
            CLOSE(fd)
        ELSE
            CALL MPI_RECV(anomaly%siga, Nc, MPI_DOUBLE_PRECISION,0, me,  comm,REC_STATUS, IERROR)
        ENDIF
        CALL MPI_BARRIER(comm,IERROR)
        time2=MPI_WTIME()
        IF (me==0) THEN
            DEALLOCATE(siga1)
            CALL PRINT_CALC_TIME('Conductivity is  loaded in' ,time2-time1)
        ENDIF
    ENDSUBROUTINE
    SUBROUTINE LOAD_FREQUENCIES_FROM_LIST(freq,comm,input_data)
        REAL(REALPARM),INTENT(INOUT),POINTER::freq(:)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        REAL(DOUBLEPARM),ALLOCATABLE::tmp(:)
        INTEGER(MPI_CTL_KIND)::me,IERROR
        INTEGER:: Nfreq
        IF (ASSOCIATED(freq)) THEN
            DEALLOCATE(freq)
            freq=>NULL()
        ENDIF
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Frequencies",tmp)
            Nfreq=SIZE(tmp)
            ALLOCATE(freq(Nfreq))
            freq=tmp
            DEALLOCATE(tmp)
        ENDIF
        CALL MPI_BCAST(Nfreq,1,MPI_INTEGER, 0, comm, IERROR)
        IF (me/=0) THEN
            ALLOCATE(freq(Nfreq))
        ENDIF
        CALL MPI_BCAST(freq,Nfreq,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
    ENDSUBROUTINE

    SUBROUTINE LOAD_FREQUENCIES_FROM_SOURCES(freq,comm,input_data)
        REAL(REALPARM),INTENT(INOUT),POINTER::freq(:)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        TYPE(FSON_VALUE), POINTER :: src_list, src
        INTEGER(MPI_CTL_KIND)::me,IERROR
        INTEGER:: Nfreq,I
        IF (ASSOCIATED(freq)) THEN
            DEALLOCATE(freq)
            freq=>NULL()
        ENDIF
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Sources", src_list)
            Nfreq=FSON_VALUE_COUNT(src_list)
            ALLOCATE(freq(Nfreq))
            DO I=1,Nfreq
		src=>FSON_VALUE_GET(src_list, I)
                CALL FSON_GET(src, "Frequency",freq(I))
            ENDDO
        ENDIF
        CALL MPI_BCAST(Nfreq,1,MPI_INTEGER, 0, comm, IERROR)
        IF (me/=0) THEN
            ALLOCATE(freq(Nfreq))
        ENDIF
        CALL MPI_BCAST(freq,Nfreq,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
    ENDSUBROUTINE

    SUBROUTINE LOAD_SOURCE(comm,input_data,N,Eint,success)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        INTEGER,INTENT(IN)::N
        COMPLEX(REALPARM),INTENT(INOUT)::Eint(1:,0:,0:,0:,1:,1:,1:)
        LOGICAL,INTENT(OUT)::success
        TYPE(FSON_VALUE), POINTER :: src_list, src
        INTEGER(MPI_CTL_KIND)::me,IERROR,L
        CHARACTER(len=DEFAULT_STRING_LEN)::fname
        CHARACTER(len=:), ALLOCATABLE::str_tmp
        L=DEFAULT_STRING_LEN
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Sources", src_list)
            src=>FSON_VALUE_GET(src_list, N)
            CALL FSON_GET(src, "Path",str_tmp)
            fname=str_tmp
        ENDIF
        CALL MPI_BCAST(fname,DEFAULT_STRING_LEN,MPI_CHARACTER, 0, comm, IERROR)
        CALL LoadIESolutionOneFileBinary(Eint,comm,fname,success)
    ENDSUBROUTINE

    FUNCTION GET_FREQ_BY_INDEX(Ifreq, comm,input_data) RESULT(freq)
        INTEGER, INTENT(IN) :: Ifreq
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        REAL(REALPARM) :: freq
        TYPE(FSON_VALUE), POINTER :: src_list, src
        INTEGER(MPI_CTL_KIND)::me,IERROR
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Sources", src_list)
	    src=>FSON_VALUE_GET(src_list, Ifreq)
            CALL FSON_GET(src, "Frequency", freq)
        ENDIF
        CALL MPI_BCAST(freq, 1, MPI_DOUBLE, 0, comm, IERROR)
    ENDFUNCTION

    SUBROUTINE LOAD_RECIEVERS(recvs,comm,input_data)
        TYPE (RECEIVERS_TYPE),INTENT(INOUT)::recvs
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        TYPE(FSON_VALUE), POINTER :: recvs_array,dom,maps,item
        INTEGER(MPI_CTL_KIND):: me,IERROR
        INTEGER:: Nd,Nr,I,J,Nz,Nm
        REAL(DOUBLEPARM),ALLOCATABLE::xshift(:),yshift(:)
        REAL(DOUBLEPARM),ALLOCATABLE::depth(:)
        CALL DELETE_RECVS(recvs)
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "Recievers", recvs_array)
            IF ( .NOT. ASSOCIATED(recvs_array))     THEN
                Nd=1
                Nz=1
                Nm=1
                CALL MPI_BCAST(Nd,1,MPI_INTEGER, 0, comm, IERROR)
                ALLOCATE(recvs%doms(Nd))
                recvs%Nd=Nd
                recvs%Nr=0
                CALL MPI_BCAST(Nz,1,MPI_INTEGER, 0, comm, IERROR)
                ALLOCATE(recvs%doms(1)%depth(Nz))
                ALLOCATE(recvs%doms(1)%recv_layer(Nz))
                ALLOCATE(recvs%doms(1)%anom_cell(Nz))
                recvs%doms(1)%Nd=Nz
                recvs%doms(1)%depth=0
                CALL MPI_BCAST(recvs%doms(1)%depth,Nz,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
                CALL MPI_BCAST(Nm,1,MPI_INTEGER, 0, comm, IERROR)
                recvs%doms(1)%Nm=Nm
                recvs%Nr=recvs%Nr+Nm*Nz
                ALLOCATE(recvs%doms(1)%xshift(Nm))
                ALLOCATE(recvs%doms(1)%yshift(Nm))
                recvs%doms(1)%xshift(1)=0
                recvs%doms(1)%yshift(1)=0
                CALL MPI_BCAST(recvs%doms(1)%xshift,Nm,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
                CALL MPI_BCAST(recvs%doms(1)%yshift,Nm,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
                RETURN
            ENDIF 
            Nd=FSON_VALUE_COUNT(recvs_array)
            CALL MPI_BCAST(Nd,1,MPI_INTEGER, 0, comm, IERROR)
            ALLOCATE(recvs%doms(Nd))
            recvs%Nd=Nd
            recvs%Nr=0
            DO I=1,Nd
                dom => FSON_VALUE_GET(recvs_array, I)
                CALL FSON_GET(dom, "Depths",depth )
                Nz=SIZE(depth)
                CALL MPI_BCAST(Nz,1,MPI_INTEGER, 0, comm, IERROR)
                ALLOCATE(recvs%doms(I)%depth(Nz))
                ALLOCATE(recvs%doms(I)%recv_layer(Nz))
                ALLOCATE(recvs%doms(I)%anom_cell(Nz))
                recvs%doms(I)%depth=depth
                DEALLOCATE(depth)
                recvs%doms(I)%Nd=Nz
                CALL MPI_BCAST(recvs%doms(I)%depth,Nz,MPI_DOUBLE_PRECISION, 0, comm, IERROR)

                CALL FSON_GET(dom, "Areas", maps)
                Nm=FSON_VALUE_COUNT(maps)
                CALL MPI_BCAST(Nm,1,MPI_INTEGER, 0, comm, IERROR)
                recvs%doms(I)%Nm=Nm
                recvs%Nr=recvs%Nr+Nm*Nz
                ALLOCATE(recvs%doms(I)%xshift(Nm))
                ALLOCATE(recvs%doms(I)%yshift(Nm))
                DO J=1,Nm
                    item => FSON_VALUE_GET(maps, J)
                    CALL FSON_GET(item, "xshift",recvs%doms(I)%xshift(J) )
                    CALL FSON_GET(item, "yshift",recvs%doms(I)%yshift(J) )
                ENDDO
                CALL MPI_BCAST(recvs%doms(I)%xshift,Nm,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
                CALL MPI_BCAST(recvs%doms(I)%yshift,Nm,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
            ENDDO
        ELSE
            CALL MPI_BCAST(Nd,1,MPI_INTEGER, 0, comm, IERROR)
            ALLOCATE(recvs%doms(Nd))
            recvs%Nd=Nd
            recvs%Nr=0
            DO I=1,Nd
                CALL MPI_BCAST(Nz,1,MPI_INTEGER, 0, comm, IERROR)
                ALLOCATE(recvs%doms(I)%depth(Nz))
                ALLOCATE(recvs%doms(I)%recv_layer(Nz))
                ALLOCATE(recvs%doms(I)%anom_cell(Nz))
                recvs%doms(I)%Nd=Nz
                CALL MPI_BCAST(recvs%doms(I)%depth,Nz,MPI_DOUBLE_PRECISION, 0, comm, IERROR)

                CALL MPI_BCAST(Nm,1,MPI_INTEGER, 0, comm, IERROR)
                recvs%doms(I)%Nm=Nm
                recvs%Nr=recvs%Nr+Nm*Nz

                ALLOCATE(recvs%doms(I)%xshift(Nm))
                ALLOCATE(recvs%doms(I)%yshift(Nm))

                CALL MPI_BCAST(recvs%doms(I)%xshift,Nm,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
                CALL MPI_BCAST(recvs%doms(I)%yshift,Nm,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
            ENDDO
        ENDIF
    ENDSUBROUTINE
#ifndef old_recvs
    SUBROUTINE LoadRecievers(recvs,comm,input_data)
        TYPE (RECEIVER_TYPE),POINTER,INTENT(INOUT)::recvs(:)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        TYPE(FSON_VALUE), POINTER :: recvs_array,item
        INTEGER(MPI_CTL_KIND):: me,IERROR
        INTEGER:: Nr,I
        REAL(DOUBLEPARM),ALLOCATABLE::zr(:),xshift(:),yshift(:)
        IF (ASSOCIATED(recvs)) THEN
            DEALLOCATE(recvs)
            recvs=>NULL()
        ENDIF
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN

            CALL FSON_GET(input_data, "Recievers", recvs_array)
            Nr=FSON_VALUE_COUNT(recvs_array)
            ALLOCATE(zr(Nr),xshift(Nr),yshift(Nr))
            DO I=1,Nr
                item => FSON_VALUE_GET(recvs_array, I)
                CALL FSON_GET(item, "xshift",xshift(I) )
                CALL FSON_GET(item, "yshift",yshift(I) )
                CALL FSON_GET(item, "depth",zr(I) )
            ENDDO
        ENDIF
        CALL MPI_BCAST(Nr,1,MPI_INTEGER, 0, comm, IERROR)
        IF (me/=0) THEN
            ALLOCATE(zr(Nr),xshift(Nr),yshift(Nr))
        ENDIF
        CALL MPI_BCAST(zr,Nr,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        CALL MPI_BCAST(xshift,Nr,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        CALL MPI_BCAST(yshift,Nr,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        ALLOCATE(recvs(Nr))
        DO I=1,Nr
            recvs(I)%zrecv=zr(I)
            recvs(I)%x_shift=xshift(I)
            recvs(I)%y_shift=yshift(I)
        ENDDO
        DEALLOCATE(zr,xshift,yshift)
    ENDSUBROUTINE
#endif
    SUBROUTINE LoadFGMRES_Ctl(fgmres_ctl,comm,input_data)
        TYPE (FGMRES_CTL_TYPE),INTENT(OUT)::fgmres_ctl
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data

        TYPE(FSON_VALUE), POINTER :: fgmres
        INTEGER :: buf_length,maxit,maxit_precond
        REAL(DOUBLEPARM)::misfit
        INTEGER(MPI_CTL_KIND):: me,IERROR
        CALL MPI_COMM_RANK(comm, me, IERROR)
        IF (me==0) THEN
            CALL FSON_GET(input_data, "FGMRES",fgmres)
            CALL FSON_GET(fgmres, "OuterBufferSize",buf_length)
            CALL FSON_GET(fgmres, "InnerBufferSize",maxit_precond)
            CALL FSON_GET(fgmres, "MaxRestart",maxit)
            CALL FSON_GET(fgmres, "Tolerance",misfit)
        ENDIF
        CALL MPI_BCAST(buf_length,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(maxit,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(maxit_precond,1,MPI_INTEGER, 0, comm, IERROR)
        CALL MPI_BCAST(misfit,1,MPI_DOUBLE_PRECISION, 0, comm, IERROR)
        fgmres_ctl%misfit=misfit
        fgmres_ctl%fgmres_maxit=maxit
        fgmres_ctl%fgmres_buf=buf_length
        fgmres_ctl%gmres_buf=maxit_precond
    ENDSUBROUTINE

    SUBROUTINE LOAD_SOLVER_CTL(solver_ctl,comm,input_data,implemented)
        TYPE (SOLVER_CTL_TYPE),INTENT(INOUT)::solver_ctl
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        LOGICAL,INTENT(OUT),OPTIONAL::implemented
        TYPE(FSON_VALUE), POINTER :: test_item
        INTEGER(MPI_CTL_KIND):: me,IERROR
        LOGICAL::tmp
        INTEGER(MPI_CTL_KIND):: L
        CHARACTER(len=:), ALLOCATABLE :: str_tmp
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_RANK(comm, me, IERROR)
        solver_ctl%input_data=>input_data
        IF (me==0) THEN
            solver_ctl%PROBLEM="MT"
            solver_ctl%SOLVE_EQUATION=.TRUE.
            solver_ctl%SAVE_SOLUTION=.TRUE.
            solver_ctl%LOAD_SOLUTION=.TRUE.
            solver_ctl%PATH_FOR_IE_SAVE="."
            solver_ctl%PATH_FOR_IE_LOAD="."
            solver_ctl%COMPUTE_EM_FIELD=.TRUE.
            solver_ctl%AT_STATIONS_ONLY=.FALSE.
            solver_ctl%PATH_FOR_STATIONS="./Stations.dat"
            solver_ctl%PATH_FOR_EM_SAVE="."

            CALL FSON_GET(input_data, "Problem type", test_item)
            IF (ASSOCIATED(test_item)) THEN
                CALL FSON_GET(test_item,&
                    & "", str_tmp)
                solver_ctl%PROBLEM=str_tmp
            ENDIF
            IF (PRESENT(implemented))   THEN
                implemented=IS_IMPLEMENTED(trim(solver_ctl%PROBLEM))
                CALL MPI_BCAST(implemented,1,MPI_LOGICAL,0,comm,IERROR)
                IF (.NOT. implemented) RETURN
            ENDIF
            solver_ctl%PROBLEM_TYPE=GET_TYPE_BY_PROBLEM_NAME(solver_ctl%PROBLEM)
            CALL FSON_GET(input_data, "Solve Equation", test_item)
            IF (ASSOCIATED(test_item)) THEN
                CALL FSON_GET(test_item,&
                    & "",  solver_ctl%SOLVE_EQUATION)
            ENDIF

            IF (solver_ctl%SOLVE_EQUATION) THEN
                CALL FSON_GET(input_data, "Save Solution", test_item)
                IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item,&
                    & "",solver_ctl%SAVE_SOLUTION)
                CALL FSON_GET(input_data, "Load Solution", test_item)
                IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item,&
                    & "",solver_ctl%LOAD_SOLUTION)
            ELSE
                solver_ctl%SAVE_SOLUTION=.FALSE.
                solver_ctl%LOAD_SOLUTION=.FALSE.
            ENDIF
        
            IF (solver_ctl%PROBLEM_TYPE==Q1D) THEN
                solver_ctl%SOLVE_EQUATION=.FALSE.
                solver_ctl%SAVE_SOLUTION=.FALSE.
            ENDIF

            IF (solver_ctl%SAVE_SOLUTION) THEN
                CALL FSON_GET(input_data, "IE solver output", test_item)
                IF (ASSOCIATED(test_item)) THEN
                    CALL FSON_GET(test_item,&
                        & "", str_tmp)
                    solver_ctl%PATH_FOR_IE_SAVE=str_tmp
                ENDIF
                CALL MK_DIR(solver_ctl%PATH_FOR_IE_SAVE)
            ENDIF

            CALL FSON_GET(input_data, "Recalculate Fields", test_item)
            IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item,&
                & "", solver_ctl%COMPUTE_EM_FIELD)
            IF (solver_ctl%COMPUTE_EM_FIELD ) THEN
                CALL FSON_GET(input_data, "EM output", test_item)
                IF (ASSOCIATED(test_item)) THEN
                    CALL FSON_GET(test_item,&
                        & "", str_tmp)

                    solver_ctl%PATH_FOR_EM_SAVE=str_tmp
                ENDIF
                CALL MK_DIR(solver_ctl%PATH_FOR_EM_SAVE)
                CALL FSON_GET(input_data, "Save all output", test_item)
                IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item, "",tmp)
                solver_ctl%AT_STATIONS_ONLY=.NOT. tmp
                IF (.NOT. solver_ctl%SOLVE_EQUATION) solver_ctl%LOAD_SOLUTION=.TRUE.
                CALL FSON_GET(input_data, "Load Solution", test_item)
                IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item,&
                    & "",solver_ctl%LOAD_SOLUTION)

                CALL FSON_GET(input_data, "Compute only anomalous field", test_item)
                IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item,&
                    & "",solver_ctl%COMPUTE_ONLY_ANOMALOUS_EM)
                CALL FSON_GET(input_data, "Save only total field", test_item)
                IF (ASSOCIATED(test_item)) CALL FSON_GET(test_item,&
                    & "",solver_ctl%SAVE_ONLY_TOTAL_EM)
            ELSE
                solver_ctl%SAVE_ONLY_TOTAL_EM=.FALSE.
                solver_ctl%COMPUTE_ONLY_ANOMALOUS_EM=.FALSE.
            ENDIF

            IF (solver_ctl%COMPUTE_ONLY_ANOMALOUS_EM)& 
                solver_ctl%SAVE_ONLY_TOTAL_EM=.FALSE.

            IF (solver_ctl%PROBLEM_TYPE==Q1D) THEN
                solver_ctl%COMPUTE_EM_FIELD=.TRUE.
                solver_ctl%LOAD_SOLUTION=.FALSE.
                solver_ctl%SAVE_ONLY_TOTAL_EM=.TRUE.
                solver_ctl%COMPUTE_ONLY_ANOMALOUS_EM=.FALSE.
            ENDIF

            IF (solver_ctl%AT_STATIONS_ONLY ) THEN
                CALL FSON_GET(input_data, "Stations", test_item)
                IF (ASSOCIATED(test_item)) THEN
                    CALL FSON_GET(test_item, "", str_tmp)
                    solver_ctl%PATH_FOR_STATIONS=str_tmp
                ENDIF
            ENDIF
            IF (solver_ctl%LOAD_SOLUTION) THEN
                CALL FSON_GET(input_data, "IE solver input", test_item)
                IF (ASSOCIATED(test_item)) THEN
                    CALL FSON_GET(test_item, "", str_tmp)
                    solver_ctl%PATH_FOR_IE_LOAD=str_tmp
                ENDIF
                CALL MK_DIR(solver_ctl%PATH_FOR_IE_LOAD)
            ENDIF
            CALL FSON_GET(input_data, "", solver_ctl%input_data)
        ELSEIF (PRESENT(implemented))       THEN
            CALL MPI_BCAST(implemented,1,MPI_LOGICAL,0,comm,IERROR)
            IF (.NOT. implemented) RETURN
        ENDIF
        L=DEFAULT_STRING_LEN
        CALL MPI_BCAST(solver_ctl%PROBLEM,L,MPI_CHARACTER,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%SOLVE_EQUATION,1,MPI_LOGICAL,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%SAVE_SOLUTION,1,MPI_LOGICAL,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%LOAD_SOLUTION,1,MPI_LOGICAL,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%PATH_FOR_IE_SAVE,L,MPI_CHARACTER,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%PATH_FOR_IE_LOAD,L,MPI_CHARACTER,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%COMPUTE_EM_FIELD,1,MPI_LOGICAL,0,comm,IERROR)

        CALL MPI_BCAST(solver_ctl%COMPUTE_ONLY_ANOMALOUS_EM,1,MPI_LOGICAL,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%SAVE_ONLY_TOTAL_EM,1,MPI_LOGICAL,0,comm,IERROR)

        CALL MPI_BCAST(solver_ctl%AT_STATIONS_ONLY,1,MPI_LOGICAL,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%PATH_FOR_STATIONS,L,MPI_CHARACTER,0,comm,IERROR)
        CALL MPI_BCAST(solver_ctl%PATH_FOR_EM_SAVE,L,MPI_CHARACTER,0,comm,IERROR)
        solver_ctl%PROBLEM_TYPE=GET_TYPE_BY_PROBLEM_NAME(solver_ctl%PROBLEM)
    ENDSUBROUTINE
    SUBROUTINE LOAD_POLYNOMIAL_DATA(input_data,porder)
        TYPE(FSON_VALUE), POINTER,INTENT(IN) ::input_data
        TYPE(POL_ORDER_TYPE),INTENT(OUT)::porder
        TYPE(FSON_VALUE), POINTER :: test_item,test_item2
        CHARACTER(LEN=2048,KIND=C_CHAR)::message 
        CALL FSON_GET(input_data, "Polynomial orders", test_item)
        porder%Nx=0
        porder%Ny=0
        porder%Nz=0
        IF (ASSOCIATED(test_item))  THEN
            CALL FSON_GET(test_item, "X", test_item2)
            IF (ASSOCIATED(test_item2)) CALL FSON_GET(test_item2, "", porder%Nx)
            CALL FSON_GET(test_item, "Y", test_item2)
            IF (ASSOCIATED(test_item2)) CALL FSON_GET(test_item2, "", porder%Ny)
            CALL FSON_GET(test_item, "Z", test_item2)
            IF (ASSOCIATED(test_item2)) CALL FSON_GET(test_item2, "", porder%Nz)
        ENDIF
        WRITE (message,'(A, I5)') 'Order of polynomial along X:',porder%Nx
        CALL LOGGER(message)
        WRITE (message,'(A, I5)') 'Order of polynomial along Y:',porder%Ny
        CALL LOGGER(message)
        WRITE (message,'(A, I5)') 'Order of polynomial along Z:',porder%Nz
        CALL LOGGER(message)

    ENDSUBROUTINE

#ifdef old_recv
    SUBROUTINE SaveOutputOneFile(Ea,Et,Ha,Ht,anomaly,recvs,freq,comm,fname)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ea(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Et(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ha(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ht(:,:,:,:)
        TYPE (RECEIVER_TYPE),POINTER,INTENT(IN)::recvs(:)
        TYPE (ANOMALY_TYPE),INTENT(IN)::anomaly
        REAL(REALPARM),INTENT(IN)::freq
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        CHARACTER(*),INTENT(IN)::fname
        CHARACTER(LEN=*), PARAMETER  :: output_fmt = "(A1, 28ES20.10E3)"
        CHARACTER(LEN=*), PARAMETER  :: title_fmt = "(A1, 28A20)"
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        INTEGER(MPI_CTL_KIND)::me, IERROR,csize
        INTEGER::Ir,Nr
        INTEGER::fsize,fshape(4),fsize2
        INTEGER::Ix,Iy,I,Ic
        COMPLEX(REALPARM),POINTER::Ea1(:,:,:,:),Et1(:,:,:,:)
        COMPLEX(REALPARM),POINTER::Ha1(:,:,:,:),Ht1(:,:,:,:)
        REAL(REALPARM)::x,y
        INTEGER::fd=DEFAULT_UNIT    
        INTEGER::OPENERROR
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        Nr=SIZE(recvs)
        fsize=SIZE(Ea)
        IF (me==0) THEN
            Ic=0
            fshape=SHAPE(Ea)
            ALLOCATE(Ea1(fshape(1),EX:EZ,fshape(3),fshape(4)))
            ALLOCATE(Et1(fshape(1),EX:EZ,fshape(3),fshape(4)))
            ALLOCATE(Ha1(fshape(1),HX:HZ,fshape(3),fshape(4)))
            ALLOCATE(Ht1(fshape(1),HX:HZ,fshape(3),fshape(4)))
            OPEN(UNIT = fd,STATUS='replace',FILE=trim(fname)//'.dat')
            WRITE (UNIT=fd,FMT=title_fmt,IOSTAT=OPENERROR) "%","x_recv","y_recv","z_recv","frequency",&
                &"Re Ex^a","Im Ex^a", "Re Ey^a", "Im Ey^a",&
                &"Re Ez^a","Im Ez^a", "Re Hx^a", "Im Hx^a",&
                &"Re Hy^a","Im Hy^a", "Re Hz^a", "Im Hz^a",&
                &"Re Ex^t","Im Ex^t", "Re Ey^t", "Im Ey^t",&
                &"Re Ez^t","Im Ez^t", "Re Hx^t", "Im Hx^t",&
                &"Re Hy^t","Im Hy^t", "Re Hz^t", "Im Hz^t"

            DO Ir=1,Nr
                DO Iy=1,anomaly%Ny_loc
                    y=Iy*anomaly%dy-anomaly%dy/2d0+recvs(Ir)%y_shift
                    DO Ix=1,anomaly%Nx
                        x=Ix*anomaly%dx-anomaly%dx/2d0+recvs(Ir)%x_shift
                        WRITE (UNIT= fd,FMT=output_fmt,IOSTAT=OPENERROR) " ",x,y,recvs(Ir)%zrecv,freq,&
                            & Ea(Ir,EX,Ix,Iy),Ea(Ir,EY,Ix,Iy),&
                            & Ea(Ir,EZ,Ix,Iy),Ha(Ir,HX,Ix,Iy),&
                            & Ha(Ir,HY,Ix,Iy),Ha(Ir,HZ,Ix,Iy),&
                            & Et(Ir,EX,Ix,Iy),Et(Ir,EY,Ix,Iy),&
                            & Et(Ir,EZ,Ix,Iy),Ht(Ir,HX,Ix,Iy),&
                            & Ht(Ir,HY,Ix,Iy),Ht(Ir,HZ,Ix,Iy)
                        Ic=Ic+1
                    ENDDO
                ENDDO
            ENDDO
        ENDIF

        IF (me/=0) THEN
            CALL MPI_SEND(Ea, fsize, MPI_DOUBLE_COMPLEX,0,me,comm, IERROR)
            CALL MPI_SEND(Ha, fsize, MPI_DOUBLE_COMPLEX, 0, me+csize,comm, IERROR)
            CALL MPI_SEND(Et, fsize, MPI_DOUBLE_COMPLEX, 0, me+2*csize,comm, IERROR)
            CALL MPI_SEND(Ht, fsize, MPI_DOUBLE_COMPLEX, 0, me+3*csize,comm, IERROR)
            CALL MPI_BARRIER(comm,IERROR)
            RETURN
        ENDIF
        DO I=1,csize-1
            CALL MPI_RECV(Ea1, fsize, MPI_DOUBLE_COMPLEX, I, I,comm,REC_STATUS, IERROR)
            CALL MPI_RECV(Ha1, fsize, MPI_DOUBLE_COMPLEX, I, I+csize,comm, REC_STATUS,IERROR)
            CALL MPI_RECV(Et1, fsize, MPI_DOUBLE_COMPLEX, I, I+2*csize,comm, REC_STATUS,IERROR)
            CALL MPI_RECV(Ht1, fsize, MPI_DOUBLE_COMPLEX, I, I+3*csize,comm, REC_STATUS,IERROR)
            DO Ir=1,Nr
                DO Iy=1,anomaly%Ny_loc
                    y=(Iy+I*anomaly%Ny_loc)*anomaly%dy-anomaly%dy/2d0+recvs(Ir)%y_shift
                    DO Ix=1,anomaly%Nx
                        x=Ix*anomaly%dx-anomaly%dx/2d0+recvs(Ir)%x_shift
                        WRITE (UNIT= fd,FMT=output_fmt) " ",x,y,recvs(Ir)%zrecv,freq,&
                            & Ea1(Ir,EX,Ix,Iy),Ea1(Ir,EY,Ix,Iy),&
                            & Ea1(Ir,EZ,Ix,Iy),Ha1(Ir,HX,Ix,Iy),&
                            & Ha1(Ir,HY,Ix,Iy),Ha1(Ir,HZ,Ix,Iy),&
                            & Et1(Ir,EX,Ix,Iy),Et1(Ir,EY,Ix,Iy),&
                            & Et1(Ir,EZ,Ix,Iy),Ht1(Ir,HX,Ix,Iy),&
                            & Ht1(Ir,HY,Ix,Iy),Ht1(Ir,HZ,Ix,Iy)
                        Ic=Ic+1
                    ENDDO
                ENDDO
            ENDDO
        ENDDO
        CLOSE(fd) 
        DEALLOCATE(Ea1,Ha1,Et1,Ht1)
        CALL MPI_BARRIER(comm,IERROR)
    ENDSUBROUTINE
#endif
    SUBROUTINE SaveOutputOneFile(Ea,Et,Ha,Ht,anomaly,recvs,freq,comm,fname,stations)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ea(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Et(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ha(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ht(:,:,:,:)
        TYPE (RECEIVERS_TYPE),INTENT(IN)::recvs
        TYPE (ANOMALY_TYPE),INTENT(IN)::anomaly
        REAL(REALPARM),INTENT(IN)::freq
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        CHARACTER(*),INTENT(IN)::fname
        REAL(REALPARM),INTENT(IN),OPTIONAL,ALLOCATABLE::stations(:,:)
        CHARACTER(LEN=*), PARAMETER  :: output_fmt = "(A1, 28ES20.10E3)"
        CHARACTER(LEN=*), PARAMETER  :: title_fmt = "(A1, 28A20)"
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        INTEGER(MPI_CTL_KIND)::me, IERROR,csize
        INTEGER::Ir,Nr
        INTEGER::fsize,fshape(4),fsize2
        INTEGER::Ix,Iy,I,Ic,Iod,Id,Im
        COMPLEX(REALPARM),POINTER::Ea1(:,:,:,:),Et1(:,:,:,:)
        COMPLEX(REALPARM),POINTER::Ha1(:,:,:,:),Ht1(:,:,:,:)
        REAL(REALPARM)::x,y
        INTEGER::fd=DEFAULT_UNIT    
        INTEGER::OPENERROR
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        fsize=SIZE(Ea)
        IF (me==0) THEN
            fshape=SHAPE(Ea)
            ALLOCATE(Ea1(fshape(1),EX:EZ,fshape(3),fshape(4)))
            ALLOCATE(Et1(fshape(1),EX:EZ,fshape(3),fshape(4)))
            ALLOCATE(Ha1(fshape(1),HX:HZ,fshape(3),fshape(4)))
            ALLOCATE(Ht1(fshape(1),HX:HZ,fshape(3),fshape(4)))
            OPEN(UNIT = fd,STATUS='replace',FILE=trim(fname)//'.dat')
            WRITE (UNIT=fd,FMT=title_fmt) "%","x_recv","y_recv","z_recv","frequency",&
                &"Re Ex^a","Im Ex^a", "Re Ey^a", "Im Ey^a",&
                &"Re Ez^a","Im Ez^a", "Re Hx^a", "Im Hx^a",&
                &"Re Hy^a","Im Hy^a", "Re Hz^a", "Im Hz^a",&
                &"Re Ex^t","Im Ex^t", "Re Ey^t", "Im Ey^t",&
                &"Re Ez^t","Im Ez^t", "Re Hx^t", "Im Hx^t",&
                &"Re Hy^t","Im Hy^t", "Re Hz^t", "Im Hz^t"
            IF (PRESENT(stations)) THEN
                CALL PRINT_FIELDS(fd,recvs,anomaly,0,freq,Ea,Et,Ha,Ht,stations)
            ELSE
                CALL PRINT_FIELDS(fd,recvs,anomaly,0,freq,Ea,Et,Ha,Ht)
            ENDIF

        ENDIF

        IF (me/=0) THEN
            CALL MPI_SEND(Ea, fsize, MPI_DOUBLE_COMPLEX,0,me,comm, IERROR)
            CALL MPI_SEND(Ha, fsize, MPI_DOUBLE_COMPLEX, 0, me+csize,comm, IERROR)
            CALL MPI_SEND(Et, fsize, MPI_DOUBLE_COMPLEX, 0, me+2*csize,comm, IERROR)
            CALL MPI_SEND(Ht, fsize, MPI_DOUBLE_COMPLEX, 0, me+3*csize,comm, IERROR)
            CALL MPI_BARRIER(comm,IERROR)
            RETURN
        ENDIF
        DO I=1,csize-1
            CALL MPI_RECV(Ea1, fsize, MPI_DOUBLE_COMPLEX, I, I,comm,REC_STATUS, IERROR)
            CALL MPI_RECV(Ha1, fsize, MPI_DOUBLE_COMPLEX, I, I+csize,comm, REC_STATUS,IERROR)
            CALL MPI_RECV(Et1, fsize, MPI_DOUBLE_COMPLEX, I, I+2*csize,comm, REC_STATUS,IERROR)
            CALL MPI_RECV(Ht1, fsize, MPI_DOUBLE_COMPLEX, I, I+3*csize,comm, REC_STATUS,IERROR)

            IF (PRESENT(stations)) THEN
                CALL PRINT_FIELDS(fd,recvs,anomaly,I,freq,Ea1,Et1,Ha1,Ht1,stations)
            ELSE
                CALL PRINT_FIELDS(fd,recvs,anomaly,I,freq,Ea1,Et1,Ha1,Ht1)
            ENDIF
        ENDDO
        CLOSE(fd) 
        DEALLOCATE(Ea1,Ha1,Et1,Ht1)
        CALL MPI_BARRIER(comm,IERROR)
    ENDSUBROUTINE

    SUBROUTINE SaveOutputOneFile_SingleType(type_mark, Et, Ht,anomaly,recvs,freq,comm,fname, bound_x, bound_y, stations)
        CHARACTER, INTENT(IN) :: type_mark
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Et(:,:,:,:)
        COMPLEX(REALPARM),POINTER,INTENT(IN)::Ht(:,:,:,:)
        TYPE (RECEIVERS_TYPE),INTENT(IN)::recvs
        TYPE (ANOMALY_TYPE),INTENT(IN)::anomaly
        REAL(REALPARM),INTENT(IN)::freq
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        CHARACTER(*),INTENT(IN)::fname
        REAL(REALPARM), INTENT(IN), OPTIONAL :: bound_x(2), bound_y(2)
        REAL(REALPARM),INTENT(IN),OPTIONAL,ALLOCATABLE::stations(:,:)
        CHARACTER(LEN=*), PARAMETER  :: output_fmt = "(A1, 28ES20.10E3)"
        CHARACTER(LEN=*), PARAMETER  :: title_fmt = "(A1, 28A20)"
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        INTEGER(MPI_CTL_KIND)::me, IERROR,csize
        INTEGER::Ir,Nr
        INTEGER::fsize,fshape(4),fsize2
        INTEGER::Ix,Iy,I,Ic,Iod,Id,Im
        COMPLEX(REALPARM),POINTER::Ea1(:,:,:,:),Et1(:,:,:,:)
        COMPLEX(REALPARM),POINTER::Ha1(:,:,:,:),Ht1(:,:,:,:)
        REAL(REALPARM)::x,y
        INTEGER::fd=DEFAULT_UNIT    
        INTEGER::OPENERROR
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        fsize=SIZE(Et)
        IF (me==0) THEN
            fshape=SHAPE(Et)
            ALLOCATE(Et1(fshape(1),EX:EZ,fshape(3),fshape(4)))
            ALLOCATE(Ht1(fshape(1),HX:HZ,fshape(3),fshape(4)))
            OPEN(UNIT = fd,STATUS='replace',FILE=trim(fname)//'.dat')
            WRITE (UNIT=fd,FMT=title_fmt) "%","x_recv","y_recv","z_recv","frequency",&
                &"Re Ex^"//type_mark, "Im Ex^"//type_mark, "Re Ey^"//type_mark, "Im Ey^"//type_mark,&
                &"Re Ez^"//type_mark, "Im Ez^"//type_mark, "Re Hx^"//type_mark, "Im Hx^"//type_mark,&
                &"Re Hy^"//type_mark, "Im Hy^"//type_mark, "Re Hz^"//type_mark, "Im Hz^"//type_mark

            IF (PRESENT(stations)) THEN
                CALL PRINT_TOTAL_FIELDS(fd,recvs,anomaly,0,freq, Et, Ht,stations)
            ELSEIF( PRESENT(bound_x) ) THEN
                CALL PRINT_TOTAL_FIELDS(fd, recvs, anomaly, 0 , freq, Et, Ht, bound_x, bound_y)
            ELSE
                CALL PRINT_TOTAL_FIELDS(fd,recvs,anomaly,0,freq, Et, Ht)
            ENDIF

        ENDIF

        IF (me/=0) THEN
            CALL MPI_SEND(Et, fsize, MPI_DOUBLE_COMPLEX,0,me,comm, IERROR)
            CALL MPI_SEND(Ht, fsize, MPI_DOUBLE_COMPLEX, 0, me+csize,comm, IERROR)
            CALL MPI_BARRIER(comm,IERROR)
            RETURN
        ENDIF
        DO I=1,csize-1
            CALL MPI_RECV(Et1, fsize, MPI_DOUBLE_COMPLEX, I, I,comm,REC_STATUS, IERROR)
            CALL MPI_RECV(Ht1, fsize, MPI_DOUBLE_COMPLEX, I, I+csize,comm, REC_STATUS,IERROR)

            IF (PRESENT(stations)) THEN
                CALL PRINT_TOTAL_FIELDS(fd,recvs,anomaly,I,freq, Et1, Ht1,stations)
            ELSEIF( PRESENT(bound_x) ) THEN
                CALL PRINT_TOTAL_FIELDS(fd, recvs, anomaly, I , freq, Et1, Ht1, bound_x, bound_y)
            ELSE
                CALL PRINT_TOTAL_FIELDS(fd,recvs,anomaly,I,freq, Et1, Ht1)
            ENDIF

        ENDDO
        CLOSE(fd) 
        !CALL SYSTEM("gzip --best --force "//trim(fname)//'.dat')
        DEALLOCATE(Et1,Ht1)
        CALL MPI_BARRIER(comm,IERROR)
    ENDSUBROUTINE


    SUBROUTINE LoadStations(filename,stations)
        REAL(REALPARM),INTENT(INOUT),ALLOCATABLE::stations(:,:)
        CHARACTER(LEN=*),INTENT(IN)::filename
        INTEGER(MPI_CTL_KIND)::me,IERROR
        INTEGER:: N
        INTEGER::fd=DEFAULT_UNIT
        OPEN(UNIT=fd,file=filename)
        READ(fd,*) N
        IF (ALLOCATED(stations)) DEALLOCATE(stations)
        ALLOCATE(stations(3,N))
        READ(fd,*) stations
        CLOSE(fd)
    ENDSUBROUTINE

    FUNCTION GET_RECV_LAT_BOUNDARIES(L, input_data) RESULT(RES)
        CHARACTER, INTENT(IN) :: L
        TYPE(FSON_VALUE), POINTER,INTENT(IN) :: input_data
        REAL(REALPARM) :: RES(2)
        TYPE(FSON_VALUE), POINTER :: test_item, recvs_array
        TYPE(FSON_VALUE), POINTER :: test_item2
        INTEGER :: Nd, I
        REAL(REALPARM) :: TMP
        RES=[-HUGE(RES(1)), HUGE(RES(1))]
        CALL FSON_GET(input_data, "Recievers", recvs_array)
        Nd=FSON_VALUE_COUNT(recvs_array)
        DO I=1,Nd
            test_item => FSON_VALUE_GET(recvs_array, I)
            CALL FSON_GET(test_item, L//" boundaries", test_item)
            IF (ASSOCIATED(test_item)) THEN
                test_item2 => FSON_VALUE_GET(test_item, 1)
                CALL FSON_GET(test_item2, "", TMP)
                RES(1)=MAX(RES(1), TMP)
                test_item2 => FSON_VALUE_GET(test_item, 2)
                CALL FSON_GET(test_item2, "", TMP)
                RES(2)=MIN(RES(2), TMP)
            ENDIF
        ENDDO
    ENDFUNCTION



    SUBROUTINE SaveIESolutionSeparate(Eint,anomaly,freq,tag,offset,fname)
        COMPLEX(REALPARM),INTENT(IN)::Eint(1:,EX:,1:,1:)
        INTEGER,INTENT(IN)::offset
        TYPE (ANOMALY_TYPE),INTENT(IN)::anomaly
        REAL(REALPARM),INTENT(IN)::freq
        INTEGER,INTENT(IN)::tag
        CHARACTER(LEN=*),INTENT(IN)::fname
        CHARACTER(LEN=*), PARAMETER  :: output_fmt = "(A1, 10ES20.10E3)"
        CHARACTER(LEN=*), PARAMETER  :: title_fmt = "(A1, 10A20)"
        CHARACTER(LEN=6):: ftag
        INTEGER::Ir,Nx,Nz,me, IERROR
        INTEGER::fsize
        INTEGER::Ix,Iy,Iz,Nyloc,s(4)
        REAL(REALPARM)::x,y,z
        INTEGER::fd=DEFAULT_UNIT
        s=SHAPE(Eint)
        Nyloc=s(4)
        WRITE (ftag,'(I5.5)') tag
        OPEN(UNIT = fd,STATUS='replace',FILE=fname//trim(ftag)//'.dat')
        WRITE (UNIT =fd,FMT=title_fmt) "%","x_c","y_c","z_c","frequency",&
            &"Re Ex","Im Ex", "Re Ey", "Im Ey",&
            &"Re Ez","Im Ez"
        Nx=anomaly%Nx
        DO Iy=1,Nyloc
            y=(Iy+offset)*anomaly%dy-anomaly%dy/2d0
            DO Ix=1,Nx
                x=Ix*anomaly%dx-anomaly%dx/2d0
                DO Iz=1,anomaly%Nz
                    z=(anomaly%z(Iz)+anomaly%z(Iz-1))/2;
                    WRITE (UNIT =fd,FMT=output_fmt) " ",x,y,z,freq,&
                        & Eint(Iz,EX,Ix,Iy),Eint(Iz,EY,Ix,Iy),&
                        & Eint(Iz,EZ,Ix,Iy)
                ENDDO
            ENDDO
        ENDDO
        CLOSE(fd)
    ENDSUBROUTINE
    SUBROUTINE SaveIESolutionOneFileBinary(Eint,comm,fname)
        COMPLEX(REALPARM),INTENT(IN)::Eint(EX:,0:,0:,0:,1:,1:,1:)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        CHARACTER(LEN=*),INTENT(IN)::fname
        INTEGER(MPI_CTL_KIND)::me, IERROR,csize
        INTEGER::fsize
        INTEGER(C_INT32_T)::fshape(7)
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        INTEGER::Ix,Iy,I,M,N
        COMPLEX(REALPARM)::Eint1(SIZE(Eint,7),SIZE(Eint)/SIZE(Eint,7))
        REAL(REALPARM)::x,y
        INTEGER::fd=DEFAULT_UNIT
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        fsize=SIZE(Eint)
        N=SIZE(Eint,7)
        M=fsize/N
        Eint1=RESHAPE(Eint,(/N,M/),ORDER=(/2,1/))
        fshape=SHAPE(Eint)
        fshape(6)=fshape(6)*csize
        IF (me==0) THEN
            OPEN(UNIT = fd,STATUS='replace',FILE=trim(fname),form='unformatted',access="stream")
            WRITE(UNIT=FD) fshape
            WRITE (UNIT =fd) Eint1
        ENDIF

        IF (me/=0) THEN
            CALL MPI_SEND(Eint1, fsize, MPI_DOUBLE_COMPLEX,0,me,comm, IERROR)
            CALL MPI_BARRIER(comm,IERROR)
            RETURN
        ENDIF
        DO I=1,csize-1
            CALL MPI_RECV(Eint1, fsize, MPI_DOUBLE_COMPLEX, I, I,comm, REC_STATUS,IERROR)
            WRITE (UNIT =fd) Eint1
        ENDDO
        CLOSE(fd)
        CALL MPI_BARRIER(comm,IERROR)
    ENDSUBROUTINE

    SUBROUTINE LoadIESolutionOneFileBinary(Eint,comm,fname,success)
        COMPLEX(REALPARM),INTENT(INOUT)::Eint(1:,0:,0:,0:,1:,1:,1:)
        INTEGER(MPI_CTL_KIND),INTENT(IN)::comm
        CHARACTER(LEN=*),INTENT(IN)::fname
        LOGICAL,INTENT(OUT)::success
        INTEGER(MPI_CTL_KIND)::me, IERROR,csize
        INTEGER::fsize
        INTEGER(C_INT32_T)::fshape(7),fshape_in(7)
        INTEGER(MPI_CTL_KIND):: REC_STATUS(MPI_STATUS_SIZE)
        INTEGER::Ix,Iy,I
        COMPLEX(REALPARM)::Eint1(SIZE(Eint,1),SIZE(Eint,2),SIZE(Eint,3),&
            &SIZE(Eint,4),SIZE(Eint,5),SIZE(Eint,6),SIZE(Eint,7))
        COMPLEX(REALPARM),ALLOCATABLE:: Ein(:,:,:,:,:,:,:)
        REAL(REALPARM)::x,y
        INTEGER::fd=DEFAULT_UNIT
        CALL MPI_COMM_RANK(comm, me, IERROR)
        CALL MPI_COMM_SIZE(comm, csize, IERROR)
        fsize=SIZE(Eint)
        fshape=SHAPE(Eint)
        IF (me/=0) THEN
            CALL MPI_BCAST(success,ONE,MPI_LOGICAL,0,comm,IERROR)
            IF (success) THEN
                CALL MPI_RECV(Eint, fsize, MPI_DOUBLE_COMPLEX,0,me,comm,REC_STATUS, IERROR)
                !               Eint=RESHAPE(Eint1,fshape,ORDER=(/7,1,2,3,4,5,6/))
            ENDIF
            CALL MPI_BARRIER(comm,IERROR)
            RETURN
        ENDIF
        IF (me==0) THEN
            INQUIRE ( FILE=trim(fname),EXIST = success)
            CALL MPI_BCAST(success,ONE,MPI_LOGICAL,0,comm,IERROR)
            IF (success) THEN
                OPEN(UNIT = fd,STATUS='old',FILE=trim(fname),form='unformatted',access="stream")
                READ (UNIT =fd) fshape_in
                fshape_in(6)=fshape_in(6)/csize
                ALLOCATE(Ein(fshape_in(7),fshape_in(1),fshape_in(2),fshape_in(3),fshape_in(4),&
                    &fshape_in(5),fshape_in(6)))
                READ (UNIT =fd) Ein
                CALL FILL_FIELD(Ein,Eint)
                DO I=1,csize-1
                    READ (UNIT =fd) Ein
                    CALL FILL_FIELD(Ein,Eint1)
                    CALL MPI_SEND(Eint1, fsize, MPI_DOUBLE_COMPLEX, I, I,comm, IERROR)
                ENDDO
                CLOSE(fd)
                DEALLOCATE(Ein)
            ELSE
                CALL LOGGER("There are no file: "//trim(fname))
            ENDIF
        ENDIF
        CALL MPI_BARRIER(comm,IERROR)
    ENDSUBROUTINE

    SUBROUTINE FILL_FIELD(Ein,Eout)
        COMPLEX(REALPARM),INTENT(IN):: Ein(:,:,:,:,:,:,:)
        COMPLEX(REALPARM),INTENT(INOUT):: Eout(:,:,:,:,:,:,:)
        INTEGER::Ic,Ipx,Ipy,Ipz 
        INTEGER::Ix,Iy,Iz
        INTEGER::shape_in(7),shape_out(7)
        Eout=C_ZERO
        shape_in=SHAPE(Ein)
        shape_out=SHAPE(Eout)
        DO Iz=1,MIN(shape_in(1),shape_out(7))
            DO Iy=1,MIN(shape_in(7),shape_out(6))
                DO Ix=1,MIN(shape_in(6),shape_out(5))
                    DO Ipy=1,MIN(shape_in(5),shape_out(4))
                        DO Ipx=1,MIN(shape_in(4),shape_out(3))
                            DO Ipz=1,MIN(shape_in(3),shape_out(2))
                                Eout(:,Ipz,Ipx,Ipy,Ix,Iy,Iz)=&            
                                    & Ein(Iz,:,Ipz,Ipx,Ipy,Ix,Iy)            
                            ENDDO
                        ENDDO
                    ENDDO
                ENDDO
            ENDDO
        ENDDO
    ENDSUBROUTINE



    SUBROUTINE ConvertNaIn(E1,E2) !Convert EM field array  E1 from "naive" format E1(x,y,z,c) to internal format E2(z,c,x,y)
        COMPLEX(REALPARM),INTENT(IN)::E1(:,:,:,:)
        COMPLEX(REALPARM),INTENT(OUT)::E2(:,:,:,:)
        INTEGER ::S1(4),S2(4),Iz,Ic
        S1=SHAPE(E1)
        S2=SHAPE(E2)
        IF (S1(3)==S2(1)) THEN
            !$OMP PARALLEL PRIVATE(Iz,Ic) DEFAULT(SHARED)
            !$OMP DO  SCHEDULE (GUIDED)!COLLAPSE(2) 
            DO Ic=EX,EZ
                DO Iz=1,S2(1)
                    E2(Iz,Ic,:,:)=E1(:,:,Iz,Ic)
                ENDDO
            ENDDO
            !$OMP END DO
            !$OMP END PARALLEL
        ELSE
            PRINT*, 'CONVERT ERROR'
        ENDIF

    END SUBROUTINE
    SUBROUTINE ConvertInNa(E1,E2) !Convert EM field array E1 from internal format E1(z,c,x,y) to "naive" E2(x,y,z,c)
        COMPLEX(REALPARM),INTENT(IN)::E1(:,:,:,:)
        COMPLEX(REALPARM),INTENT(OUT)::E2(:,:,:,:)
        INTEGER ::S1(4),S2(4),Ic,Iz
        S1=SHAPE(E1)
        S2=SHAPE(E2)
        IF (S1(1)==S2(3)) THEN
            !$OMP PARALLEL PRIVATE(Iz,Ic) DEFAULT(SHARED)
            !$OMP DO   SCHEDULE (GUIDED) !COLLAPSE(2)
            DO Ic=EX,EZ
                DO Iz=1,S1(1)
                    E2(:,:,Iz,Ic)=E1(Iz,Ic,:,:)
                ENDDO
            ENDDO
            !$OMP END DO
            !$OMP END PARALLEL
        ELSE
            PRINT*, 'CONVERT ERROR 1',S1
            PRINT*, 'CONVERT ERROR 2',S2
        ENDIF

    END SUBROUTINE

    SUBROUTINE MK_DIR(dirname) 
        CHARACTER(len=*),INTENT(IN)::dirname
        CALL SYSTEM("mkdir -p "//trim(dirname))
    ENDSUBROUTINE

    FUNCTION IS_IMPLEMENTED(problem) RESULT(RES)
        CHARACTER(len=*),INTENT(IN)::problem
        LOGICAL::RES
        INTEGER::I
        RES=.TRUE.
        DO I=MT,NOT_IMPLEMENTED-1
            IF (TRIM(problem)==TRIM(PROBLEM_NAMES(I))) RETURN
        ENDDO
        !-------------------- TESTS-------------------------------------!
        SELECT CASE(trim(problem))
        CASE ("QUASI_1D")
            RES=.TRUE.
        CASE ("TEST")
            RES=.TRUE.
        CASE ("TEST IE")
            RES=.TRUE.
        CASE ("TEST IE2")
            RES=.TRUE.
        CASE ("TEST IE3")
            RES=.TRUE.
        CASE ("TEST IE4")
            RES=.TRUE.
        CASE ("TEST RC")
            RES=.TRUE.
        CASE ("TEST DISTRIBUTED")
            RES=.TRUE.
        CASE DEFAULT
            RES=.FALSE.
        ENDSELECT

    ENDFUNCTION

    FUNCTION GET_TYPE_BY_PROBLEM_NAME(problem) RESULT(RES)
        CHARACTER(len=*),INTENT(IN)::problem
        INTEGER::RES
        INTEGER::I
        IF (IS_IMPLEMENTED(problem)) THEN
            DO I=MT,NOT_IMPLEMENTED-1
                RES=I
                IF (TRIM(problem)==TRIM(PROBLEM_NAMES(I))) RETURN
            ENDDO
            RES=TESTS
        ELSE
            RES=NOT_IMPLEMENTED
        ENDIF
    ENDFUNCTION

    ELEMENTAL   FUNCTION ROUND10(X) RESULT(RES)
        REAL(REALPARM), INTENT(IN)::X
        REAL(REALPARM) ::RES
        REAL(REALPARM) :: A
        CHARACTER(len=16) :: str
#ifndef use_round_10
        RES=X
        RETURN
#else
        A=FRACTION(X)
        WRITE(str, FMT='(F16.10)') A
        A=R_ZERO
        READ (str,*) A
        RES=R_ZERO
        RES=A*RADIX(A)**EXPONENT(X)
#endif
    ENDFUNCTION

END MODULE
